def main():

    import matplotlib
    matplotlib.rcParams.update({'font.size': 22})
    import pylab
    import numpy

    def calc_m2c(m, r, rs, g, n):
        return ((-1 + g)*(-(r**(1 + n)*(6 + n*(-2 + rs) - 2*rs)*rs**2) - 2*(-2 + n)*r**n*rs**3 + 2*r**3*rs**n + (-2 + n)*r**4*rs**n))/((2 + (-1 + g)*m**2)*(-2 + n)*r*(-(r**n*rs**3) + r**3*rs**n))

    gamma = 4./3.
    eta = 2.9
    rs = 6.29492

    pylab.figure(1)
    x_list = numpy.array([])
    y_list = numpy.array([])
    file_list = ['mach_beyond_inner_sonic.csv',
                 'mach_inner_sonic2stagnation.csv',
                 'mach_beyond_stagnation.csv']
    raw_data = [numpy.genfromtxt(fname, delimiter=',')
                for fname in file_list]
    r_list = numpy.concatenate([itm.T[0] for itm in raw_data])
    m_list = numpy.concatenate([itm.T[1] for itm in raw_data])
    pylab.semilogx(r_list, m_list, linewidth=4)
    pylab.xlabel('Radius')
    pylab.ylabel('Mach number')
    pylab.tight_layout()

    pylab.figure(2)
    c_list = calc_m2c(m_list,
                      r_list,
                      rs,
                      gamma,
                      eta)
    pylab.semilogx(r_list, c_list, linewidth=4)
    pylab.xlabel('Radius')
    pylab.ylabel('Sound speed')
    pylab.tight_layout()

    pylab.figure(3)
    u_list = m_list*c_list
    d_list = (r_list**(3-eta)-rs**(3-eta))/r_list**2/(3-eta)/u_list
    pylab.loglog(r_list, d_list, linewidth=4)
    pylab.xlabel('Radius')
    pylab.ylabel('Density')
    pylab.tight_layout()
    pylab.show()

if __name__ == '__main__':

    main()
